library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity cnt_D4 is
port(
--INPUTS
C   : in std_logic;
nE  : in std_logic;
--OUTPUTS
q   : out std_logic_vector(5 downto 1)
);
end;

architecture cnt_D4_rtl of cnt_D4 is

signal CNT  : std_logic_vector(3 downto 0):="0000";
signal D6   : std_logic;
signal D6_C : std_logic;

begin

    q       <= D6&CNT;
    D6_C    <= not CNT(3);

    process(C,nE)
    begin
        if C'event and C = '1' then
            if nE = '0' then
                CNT <= "1001";
            else
                CNT <= CNT+"0001";
            end if;
        end if;
    end process;
    
    process(D6_C,nE)
    begin
        if nE = '0' then
            D6 <= '1';
        elsif D6_C'event and D6_C = '1' then
            D6 <= not D6;
        end if;
    end process;

end cnt_D4_rtl;